﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using WebApi.Core.Database;

namespace WebApi.Core.Migrations
{
    [DbContext(typeof(ResidencialDb))]
    partial class ResidencialDbModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "2.1.14-servicing-32113")
                .HasAnnotation("Relational:MaxIdentifierLength", 128)
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("WebApi.Core.Database.Entities.CalleEntity", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Distancia");

                    b.Property<string>("Nombre")
                        .HasMaxLength(20);

                    b.HasKey("Id");

                    b.ToTable("Calle");
                });

            modelBuilder.Entity("WebApi.Core.Database.Entities.ParentescoEntity", b =>
                {
                    b.Property<int>("Id");

                    b.Property<string>("Descripcion")
                        .HasMaxLength(30);

                    b.HasKey("Id");

                    b.ToTable("Parentesco");

                    b.HasData(
                        new { Id = 1, Descripcion = "Ninguno" },
                        new { Id = 2, Descripcion = "Hermano" },
                        new { Id = 3, Descripcion = "Esposo" },
                        new { Id = 4, Descripcion = "Primo" },
                        new { Id = 5, Descripcion = "Sobrino" },
                        new { Id = 6, Descripcion = "Padre" },
                        new { Id = 7, Descripcion = "Hijo" },
                        new { Id = 8, Descripcion = "Otro" }
                    );
                });

            modelBuilder.Entity("WebApi.Core.Database.Entities.ResidenciaEntity", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int?>("CalleId");

                    b.Property<DateTime?>("CreateDate");

                    b.Property<string>("Numero");

                    b.Property<int?>("Piso");

                    b.Property<bool>("Poblada");

                    b.Property<int?>("PropietarioId");

                    b.Property<int?>("TipoResidenciaId");

                    b.Property<string>("UniqueIdentifier");

                    b.Property<DateTime?>("UpdateDate");

                    b.HasKey("Id");

                    b.HasIndex("CalleId");

                    b.HasIndex("PropietarioId");

                    b.HasIndex("TipoResidenciaId");

                    b.HasIndex("Numero", "CalleId")
                        .IsUnique()
                        .HasFilter("[Numero] IS NOT NULL AND [CalleId] IS NOT NULL");

                    b.ToTable("Residencia");
                });

            modelBuilder.Entity("WebApi.Core.Database.Entities.ResidenteEntity", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<bool>("Activo");

                    b.Property<string>("Apellido")
                        .HasMaxLength(20);

                    b.Property<DateTime?>("CreateDate");

                    b.Property<string>("DNI");

                    b.Property<string>("Genero")
                        .HasMaxLength(1);

                    b.Property<DateTime?>("Nacimiento")
                        .HasColumnType("date");

                    b.Property<string>("Nombre")
                        .HasMaxLength(20);

                    b.Property<int?>("ParentescoId");

                    b.Property<int?>("ResidenciaId");

                    b.Property<string>("Telefono");

                    b.Property<int?>("TipoResidenteId");

                    b.Property<DateTime?>("UpdateDate");

                    b.HasKey("Id");

                    b.HasIndex("DNI")
                        .IsUnique()
                        .HasFilter("[DNI] IS NOT NULL");

                    b.HasIndex("ParentescoId");

                    b.HasIndex("ResidenciaId");

                    b.HasIndex("TipoResidenteId");

                    b.ToTable("Residente");
                });

            modelBuilder.Entity("WebApi.Core.Database.Entities.RoleEntity", b =>
                {
                    b.Property<int>("Id");

                    b.Property<string>("Name");

                    b.HasKey("Id");

                    b.ToTable("Roles");

                    b.HasData(
                        new { Id = 1, Name = "Administrador" },
                        new { Id = 2, Name = "Guardia" },
                        new { Id = 3, Name = "Residente" }
                    );
                });

            modelBuilder.Entity("WebApi.Core.Database.Entities.TipoResidenciaEntity", b =>
                {
                    b.Property<int>("Id");

                    b.Property<string>("Descripcion")
                        .HasMaxLength(20);

                    b.HasKey("Id");

                    b.ToTable("TipoResidencia");

                    b.HasData(
                        new { Id = 1, Descripcion = "Apartamento" },
                        new { Id = 2, Descripcion = "Casa" },
                        new { Id = 3, Descripcion = "Negocio" }
                    );
                });

            modelBuilder.Entity("WebApi.Core.Database.Entities.TipoResidenteEntity", b =>
                {
                    b.Property<int>("Id");

                    b.Property<string>("Descripcion")
                        .HasMaxLength(20);

                    b.HasKey("Id");

                    b.ToTable("TipoResidente");

                    b.HasData(
                        new { Id = 1, Descripcion = "Propietario" },
                        new { Id = 2, Descripcion = "Inquilino" },
                        new { Id = 3, Descripcion = "Habitante" }
                    );
                });

            modelBuilder.Entity("WebApi.Core.Database.Entities.UserEntity", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<DateTime?>("CreateDate");

                    b.Property<string>("Email");

                    b.Property<string>("EncodeString");

                    b.Property<bool>("IsLocked");

                    b.Property<string>("Password");

                    b.Property<int?>("RoleId");

                    b.Property<string>("UserName");

                    b.HasKey("Id");

                    b.HasIndex("RoleId");

                    b.ToTable("User");
                });

            modelBuilder.Entity("WebApi.Core.Database.Entities.VehiculoEntity", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Descripcion")
                        .HasMaxLength(30);

                    b.Property<string>("Matricula")
                        .HasMaxLength(20);

                    b.Property<int?>("ResidenciaEntityId");

                    b.Property<int?>("ResidenteId");

                    b.HasKey("Id");

                    b.HasIndex("ResidenciaEntityId");

                    b.HasIndex("ResidenteId");

                    b.ToTable("Vehiculo");
                });

            modelBuilder.Entity("WebApi.Core.Database.Entities.VisitaEntity", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<DateTime?>("DarEntrada");

                    b.Property<DateTime?>("Llegada");

                    b.Property<string>("Motivo")
                        .HasMaxLength(15);

                    b.Property<string>("Nota");

                    b.Property<bool>("Reportado");

                    b.Property<int?>("ResidenciaId");

                    b.Property<DateTime?>("Salida");

                    b.Property<string>("VisitanteDNI");

                    b.Property<string>("VisitanteNombre");

                    b.HasKey("Id");

                    b.HasIndex("ResidenciaId");

                    b.ToTable("Visita");
                });

            modelBuilder.Entity("WebApi.Core.Database.Entities.ResidenciaEntity", b =>
                {
                    b.HasOne("WebApi.Core.Database.Entities.CalleEntity", "Calle")
                        .WithMany("GetResidencias")
                        .HasForeignKey("CalleId");

                    b.HasOne("WebApi.Core.Database.Entities.ResidenteEntity", "Propietario")
                        .WithMany("GetResidencias")
                        .HasForeignKey("PropietarioId")
                        .OnDelete(DeleteBehavior.SetNull);

                    b.HasOne("WebApi.Core.Database.Entities.TipoResidenciaEntity", "TipoResidencia")
                        .WithMany("Residencias")
                        .HasForeignKey("TipoResidenciaId");
                });

            modelBuilder.Entity("WebApi.Core.Database.Entities.ResidenteEntity", b =>
                {
                    b.HasOne("WebApi.Core.Database.Entities.ParentescoEntity", "Parentesco")
                        .WithMany("Residentes")
                        .HasForeignKey("ParentescoId");

                    b.HasOne("WebApi.Core.Database.Entities.ResidenciaEntity", "Residencia")
                        .WithMany("GetResidentes")
                        .HasForeignKey("ResidenciaId")
                        .OnDelete(DeleteBehavior.SetNull);

                    b.HasOne("WebApi.Core.Database.Entities.TipoResidenteEntity", "TipoResidente")
                        .WithMany("Residentes")
                        .HasForeignKey("TipoResidenteId");
                });

            modelBuilder.Entity("WebApi.Core.Database.Entities.UserEntity", b =>
                {
                    b.HasOne("WebApi.Core.Database.Entities.RoleEntity", "Role")
                        .WithMany("Users")
                        .HasForeignKey("RoleId");
                });

            modelBuilder.Entity("WebApi.Core.Database.Entities.VehiculoEntity", b =>
                {
                    b.HasOne("WebApi.Core.Database.Entities.ResidenciaEntity")
                        .WithMany("GetVehiculos")
                        .HasForeignKey("ResidenciaEntityId");

                    b.HasOne("WebApi.Core.Database.Entities.ResidenteEntity", "Residente")
                        .WithMany("GetVehiculos")
                        .HasForeignKey("ResidenteId");
                });

            modelBuilder.Entity("WebApi.Core.Database.Entities.VisitaEntity", b =>
                {
                    b.HasOne("WebApi.Core.Database.Entities.ResidenciaEntity", "Residencia")
                        .WithMany("GetVisitas")
                        .HasForeignKey("ResidenciaId");
                });
#pragma warning restore 612, 618
        }
    }
}
